commit 0abf53c10f45abc88435d727ae3e9de7ceeedf77
Author: Alex Coplan <alex.coplan@arm.com>
Date:   Tue Jul 15 11:37:58 2025

    aarch64: Fix predication of FP8 FDOT insns [PR120986]
    
    The predication of the SVE2 FP8 dot product insns was relying on the
    architectural dependency:
    
    FEAT_FP8DOT2 => FEAT_FP8DOT4
    
    which was relaxed in GCC as of
    r15-7480-g299a8e2dc667e795991bc439d2cad5ea5bd379e2, thus leading to
    unrecognisable insn ICEs when compiling a two-way FDOT with just
    +fp8dot2.  This patch introduces a new mode iterator which selectively
    enables the appropriate mode(s) depending on which of the FP8DOT{2,4}
    features are available, and uses it to fix the predication of the
    patterns.
    
    gcc/ChangeLog:
    
            PR target/120986
            * config/aarch64/aarch64-sve2.md (@aarch64_sve_dot<mode>):
            Switch mode iterator from SVE_FULL_HSF to new iterator;
            remove insn predicate as this is now taken care of by conditions
            in the mode iterator.
            (@aarch64_sve_dot_lane<mode>): Likewise.
            * config/aarch64/iterators.md (SVE_FULL_HSF_FP8_FDOT): New.
    
    gcc/testsuite/ChangeLog:
    
            PR target/120986
            * gcc.target/aarch64/pr120986-1.c: New test.
    
    (cherry picked from commit 75eabf69d805b7effb5e50f0ed53f45d6a2f596a)

diff --git a/gcc/testsuite/gcc.target/aarch64/pr120986-1.c b/gcc/testsuite/gcc.target/aarch64/pr120986-1.c
new file mode 100644
index 00000000000..e3bc56c4afe
--- /dev/null
+++ b/gcc/testsuite/gcc.target/aarch64/pr120986-1.c
@@ -0,0 +1,10 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -march=armv8.2-a+sve2+fp8dot2" } */
+#include <arm_sve.h>
+
+/* This triggered an ICE with an unrecognizable insn due to incorrect gating of
+   the insn in the backend.  */
+svfloat16_t foo(svfloat16_t a, svmfloat8_t b, svmfloat8_t c, unsigned long fpm)
+{
+  return svdot_lane_fpm (a, b, c, 0, fpm);
+}

